#!/usr/bin/env python
# -*- coding: utf-8 -*-
# -*- Python -*-

import sys
import os
sys.path.append("../../etc")
from set_env import *
sys.path.append(LibDir)
from rtc_handle import *
sys.path.append(SrcDir+'/tools/geo')
from geo import *
sys.path.append(BinDir+"/comp")
import _GlobalIDL
import pa10act_ctrl

global pi, hf, ct
pi = 3.1415926535897931
side_size = 150
hf = side_size / 2.0
##
#
def calib(mode) :
  global pi, side_size, hf
  # 待機位置・姿勢の生成
  if(mode == 1) :
    w_deg = 0.0
    ct = [500, 500, 400]
    pf = [ct[0], ct[1], ct[2], 0.0, 180.0, w_deg]
  elif(mode == 2) :
    w_deg = 135.0
    ct = [700/sqrt(2), -700/sqrt(2), 320]
    pf = [ct[0], ct[1], ct[2], 0.0, 180.0, w_deg]
  else :
    return
  # 待機位置・姿勢へ移行
  pa10act_ctrl.go_to(pf)
  # キャリブレーション開始
  print("  CALIB DEMO START..")

  global pos1 , pos2 , pos3 , pos4 , pos5 , pos6 , pos7
  global pos8 , pos9 , pos10, pos11, pos12, pos13, pos14
  pos1  = [(ct[0]+hf), (ct[1]+hf), (ct[2]+hf), 0.0, 180.0, w_deg]
  pos2  = [(ct[0]-hf), (ct[1]+hf), (ct[2]+hf), 0.0, 180.0, w_deg]
  pos3  = [ ct[0]    ,  ct[1]    , (ct[2]+hf), 0.0, 180.0, w_deg]
  pos4  = [(ct[0]+hf), (ct[1]-hf), (ct[2]+hf), 0.0, 180.0, w_deg]
  pos5  = [(ct[0]-hf), (ct[1]-hf), (ct[2]+hf), 0.0, 180.0, w_deg]
  pos6  = [ ct[0]    , (ct[1]+hf),  ct[2]    , 0.0, 180.0, w_deg]
  pos7  = [(ct[0]+hf),  ct[1]    ,  ct[2]    , 0.0, 180.0, w_deg]
  pos8  = [(ct[0]-hf),  ct[1]    ,  ct[2]    , 0.0, 180.0, w_deg]
  pos9  = [ ct[0]    , (ct[1]-hf),  ct[2]    , 0.0, 180.0, w_deg]
  pos10 = [(ct[0]+hf), (ct[1]+hf), (ct[2]-hf), 0.0, 180.0, w_deg]
  pos11 = [(ct[0]-hf), (ct[1]+hf), (ct[2]-hf), 0.0, 180.0, w_deg]
  pos12 = [ ct[0]    ,  ct[1]    , (ct[2]-hf), 0.0, 180.0, w_deg]
  pos13 = [(ct[0]+hf), (ct[1]-hf), (ct[2]-hf), 0.0, 180.0, w_deg]
  pos14 = [(ct[0]-hf), (ct[1]-hf), (ct[2]-hf), 0.0, 180.0, w_deg]
  global pos_list
  pos_list = [pos1,pos2,pos3,pos4,pos5,pos6,pos7,pos8,pos9,pos10,pos11,pos12,pos13,pos14]

  cnt = 1
  for pos in pos_list :
    print"  move to %d.." % cnt,
    print"  X %.1f" % pos[0],
    print"  Y %.1f" % pos[1],
    print"  Z %.1f" % pos[2]
    raw_input("  OK?")
    pa10act_ctrl.go_to(pos)
    cnt += 1

  file = open('3d.txt','w')
  for pos in pos_list :
    str_x = "%.1f " % pos[0]
    str_y = "%.1f " % pos[1]
    str_z = "%.1f\n"% pos[2]
    file.write(str_x)
    file.write(str_y)
    file.write(str_z)
  file.close()
  print("  Write POSITION down >> 3d.txt ..")
  raw_input("  move ready position. OK?")
  pa10act_ctrl.go_to(pa10act_ctrl.point1)
##
# 開始準備
yn = raw_input("need ready?  :y or n  ")
if(yn == "y") :
  pa10act_ctrl.move_joint(pa10act_ctrl.j_ready)
pa10act_ctrl.set_tool([-30.0, 0.0, 50.0])
while(1) :
  mode = raw_input("Select mode  [ table: 1   RH: 2   QUIT: 3]  :")
  if(int(mode) == 3) :
    break
  calib(int(mode))
pa10act_ctrl.end(pa10act_ctrl.env)
