#!/usr/bin/env python
# -*- coding: utf-8 -*-

###############################
#   set up                #
###############################

# importするモジュールのpath
import sys
import os
import time
import string
import copy
import traceback
sys.path.append("../../etc")
from set_env import *
sys.path.append(LibDir)
from rtc_handle import *
sys.path.append(SrcDir+'/tools/geo')
from geo import *
sys.path.append(BinDir+"/comp")
import _GlobalIDL
#
# 制御スクリプトのimport
import simpa10_ctrl
if __debug__ : 
  import VGRholder_ctrl
  import VGRdrink_ctrl

from math import *
#
# ERRORコード
err_code = {
"OK" :0,
"RH_LOCATION_ERROR" :-1,
"HOLDER_NOT_EMPTY"  :-2,
"LACK_OF_DRINK"     :-3
}
# ホルダ挿入口格納用のリスト
hole_pos = []

# holder hole positions
if not __debug__ : 
  for i in range(4) : 
    hole_pos.append([450.0, -450.0, 250.0, 0.0, 180.0, 0.0])
# dummy drink positions
if not __debug__ :
  can1 = [ 635, 316, 356 + 40.0, 0.0, 180.0, 0.0]
  can2 = [ 526, 431, 355 + 40.0, 0.0, 180.0, 0.0]
  can3 = [ 418, 542, 356 + 40.0, 0.0, 180.0, 0.0]
  abv_can1 = [ 635, 316, 356 + 300.0, 0.0, 180.0, 0.0]
  abv_can2 = [ 526, 431, 355 + 300.0, 0.0, 180.0, 0.0]
  abv_can3 = [ 418, 542, 356 + 300.0, 0.0, 180.0, 0.0]
##
# create env
env = RtmEnv(sys.argv,[ PACT_NS ])
for ns in env.name_space :
  env.name_space[ns].list_obj()

###############################
#   関数定義                  #
###############################

##
# handle開始
def start_handle(env) :
  # PA10SystemController
  global PA10SysCtrlr
  PA10SysCtrlr = env.name_space[ PACT_NS ].rtc_handles['PA10SystemController0.rtc']
  PA10SysCtrlr.services['PA10SysCtrlrProv'].provided['SystemControl'].narrow_ref(globals())
start_handle(env)
##
#
def deactivate_all() :
  if __debug__ : 
    VGRdrink_ctrl.deactivate()
    GRholder_ctrl.deactivate()
  simpa10_ctrl.deactivate()
##
#
def end_all(env) :
  deactivate_all()
  simpa10_ctrl.deactivate()
  VGRdrink_ctrl.deactivate()
  VGRholder_ctrl.deactivate()
##
# check holder is empty or not
"""
def empty_check() :
  print" Now checking whether drink holder is empty or not."
  trial = 0
  lim = 10
  while trial < lim :
    trial += 1
    VGRholder_ctrl.start_recog(0)
    time.sleep(4.0)
    VGRholder_ctrl.get_data()
    data = VGRholder_ctrl.res_data
    min_rel = 0.50
    if(data.getRecognitionReliability() > min_rel) :
      return 1
  print" holder is empty."
  return 0
"""
##
# error output
"""
def error_check(st) :
  if(st == err_code["RH_LOCATION_ERROR"]) :
    ctrl_term.services['PA10StateChage'].provided['StateChangeFromPA10'].ref.SetState( st, "RH_LOCATION_ERROR")
    sys.exit(" RH_LOCATION_ERROR")
     
  elif(st == err_code["HOLDER_NOT_EMPTY"]) :
    ctrl_term.services['PA10StateChage'].provided['StateChangeFromPA10'].ref.SetState( st, "HOLDER_NOT_EMPTY")
    sys.exit(" HOLDER_NOT_EMPTY")
    
  elif(st == err_code["LACK_OF_DRINK"]) :
    ctrl_term.services['PA10StateChage'].provided['StateChangeFromPA10'].ref.SetState( st, "LACK_OF_DRINK")
    sys.exit(" LACK_OF_DRINK")
"""
##
#  ドリンクホルダ挿入口の認識
#  PA10座標系におけるホルダ挿入口の座標を算出
#    hole_pos：ホルダ挿入口の座標(PA10座標系)
def recog_holder(hole_pos) :
  if __debug__ : 
    if(VGRholder_ctrl.lookat("holder") == 1) :
      # RH認識失敗 
      return err_code["RH_LOCATION_ERROR"]
    # ホルダ挿入口初期化
    del hole_pos[:]
    # RH座標系：ドリンクホルダの中心を原点とする座標系
    # OpenVGRで認識したホルダの座標：RH座標系の原点
    #                 回転行列：RH座標系の座標軸ベクトル
    # 
  """
  RHmark_vec = [0.0, 0.0, 0.0]
  data.getVector(RHmark_vec)
  mat = [0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0]
  data.getRotateMat(mat)
  """
  # RH座標系原点の設定
  new_axis = MATRIX([])
  if __debug__ :
    for i in range(4) :
      hole_pos.append([VGRholder_ctrl.data[11], VGRholder_ctrl.data[15], VGRholder_ctrl.data[19], 0.0, 180.0, 45.0])

    # RH座標系座標軸の設定
    new_axis[0][1] = fabs(VGRholder_ctrl.data[8])
    new_axis[1][1] = fabs(VGRholder_ctrl.data[9])
    new_axis[2][1] = VGRholder_ctrl.data[10]
    tmp = VECTOR()
    tmp[0] = fabs(VGRholder_ctrl.data[8])
    tmp[1] = fabs(VGRholder_ctrl.data[9])
    tmp[2] = VGRholder_ctrl.data[10]
    rot_mat = MATRIX([])
    rot_mat.__init__(c = -pi/2.0)
    tmp = rot_mat.__mul__(tmp)
    for i in range(3) :
      new_axis[i][0] = tmp[i]
    # RH座標系におけるホルダ挿入口の座標を設定
    new_axis.trans()
  hole_vec = []
  for i in range(4) :
    hole_vec.append(VECTOR())
  # 挿入口1: x, y, z (RH座標系)
  hole_vec[0][0] =  50
  hole_vec[0][1] = -48
  # 挿入口2: x, y, z (RH座標系)
  hole_vec[1][0] = -50
  hole_vec[1][1] =  52
  # 挿入口3: x, y, z (RH座標系)
  hole_vec[2][0] = -50
  hole_vec[2][1] = -48
  # 挿入口4: x, y, z (RH座標系)
  hole_vec[3][0] =  50
  hole_vec[3][1] =  52
  # 挿入口座標の座標変換  RH座標系 -> PA10座標系
  for i in range(4) :
    hole_vec[i] = new_axis.__mul__(hole_vec[i])
    for j in range(3) :
      hole_pos[i][j] = hole_pos[i][j] + hole_vec[i][j]
  for i in range(4) :
    print"  hole_pos[%d} = " % i,
    print("[ %.3f, " % hole_pos[i][0]),
    print("%.3f, " % hole_pos[i][1]),
    print("%.3f ]" % hole_pos[i][2])
  # check holder is empty or not
  """
  if(empty_check() == 1) :
   return err_code["HOLDER_NOT_EMPTY"]
  """
  # 認識成功
  return err_code["OK"]
#
if not __debug__ : 
  a_list =[]
  a_list.append(abv_can1)
  a_list.append(abv_can2)
  a_list.append(abv_can3)
  t_list = []
  t_list.append(can1)
  t_list.append(can2)
  t_list.append(can3)
##
#  PA10によるドリンクの給仕
def set_drinks(set_pos) :
  drinkcnt = 0
  drinknum = len(set_pos)
  id = 0
  simpa10_ctrl.hand_open(simpa10_ctrl.hand_disp,0.05)
  time.sleep(3)
  while(drinkcnt < drinknum) :
    # ドリンク認識と座標取得
    if __debug__ : 
      if(VGRdrink_ctrl.lookat("can") == 1) :
        # ドリンクなし
        return err_code["LACK_OF_DRINK"]
      abv_tgt = [ VGRdrink_ctrl.data[11], VGRdrink_ctrl.data[15], VGRdrink_ctrl.data[19] + 300.0, 0.0, 180.0, 0.0]
      tgt     = [ VGRdrink_ctrl.data[11], VGRdrink_ctrl.data[15], VGRdrink_ctrl.data[19] +  50.0, 0.0, 180.0, 0.0]
    else :
      abv_tgt = a_list[i]
      tgt     = t_list[i]
    if(simpa10_ctrl.can_move(abv_tgt) == 1 or simpa10_ctrl.can_move(tgt) == 1) :
      continue
    # ドリンク上方へアームを移動
    simpa10_ctrl.move_joint(simpa10_ctrl.j_table)
    simpa10_ctrl.go_to(abv_tgt)
    str = raw_input("  Catch an object?  (n: Recognition again, q: Quit scenario, other keys: OK) ")
    if(  str == 'n') :
      continue
    elif(str == 'q') :
      simpa10_ctrl.go_to(simpa10_ctrl.point1)
      PA10SysCtrlr.services['PA10SysCtrlrProv'].provided['SystemControl'].ref.PA10SetStatus(4)
      end_all(env)
      sys.exit("quit scenaio.")
    # ドリンク把持
    simpa10_ctrl.go_to(tgt)
    simpa10_ctrl.hand_open(simpa10_ctrl.hand_disp,0)
    time.sleep(4)
    # ドリンク持ち上げ
    simpa10_ctrl.go_to(abv_tgt)
    simpa10_ctrl.move_joint(simpa10_ctrl.j_holder)
    abv_set_pos = [ set_pos[drinkcnt][0], set_pos[drinkcnt][1], set_pos[drinkcnt][2] + 300.0, 0.0, 180.0, 45.0]
    lower_set_pos = [ set_pos[drinkcnt][0], set_pos[drinkcnt][1], set_pos[drinkcnt][2] - 30.0, 0.0, 180.0, 45.0]
    # ホルダ挿入口へドリンクを挿入
    simpa10_ctrl.go_to(abv_set_pos)
    simpa10_ctrl.go_to(set_pos[drinkcnt])
    str = raw_input("down more?")
    if(str == "y") :
      simpa10_ctrl.go_to(lower_set_pos)
    simpa10_ctrl.hand_open(simpa10_ctrl.hand_disp,0.05)
    time.sleep(4)
    simpa10_ctrl.go_to(abv_set_pos)
    drinkcnt += 1
  # 待機場所へアームを移動
  simpa10_ctrl.go_to(simpa10_ctrl.point1)
  return err_code["OK"]
  
###############################
#  デモ開始                    #
###############################

try :
  argvs = sys.argv
  argc = len(argvs)
  drinknum = string.atoi(argvs[1])
  # ホルダの認識
  status = recog_holder(hole_pos)
  #error_check(status)
  # ホルダの位置をチェック
  for i in range(len(hole_pos)) :
    if(simpa10_ctrl.can_move(hole_pos[i]) == 1) :
      # PA10可動範囲外(ホルダ挿入口へドリンク挿入不可能)
      #ctrl_term.services['PA10StateChage'].provided['StateChangeFromPA10'].ref.SetState( st, "RH_LOCATION_ERROR")
      PA10SysCtrlr.services['PA10SysCtrlrProv'].provided['SystemControl'].ref.PA10SetStatus(4)
      end_all(env)
      sys.exit("RH_LOCATION_ERROR(out of PA10 movable area!)")
  # ドリンク給仕
  use_hole = list()
  if(argc != 2 or drinknum > 4) :
    print" Usage: $ python %s drink_number(<= 4)" % argvs[0]
  for i in range(drinknum) :
    use_hole.append(copy.deepcopy(hole_pos[i]))
    use_hole[i][2] = use_hole[i][2] + 110
  simpa10_ctrl.set_joint_vel(0.8)
  status = set_drinks(use_hole)
  simpa10_ctrl.set_joint_vel(0.1)
  #error_check(status)
  PA10SysCtrlr.services['PA10SysCtrlrProv'].provided['SystemControl'].ref.PA10SetStatus(4)
  end_all(env)
  print"  Drink service Completed!"
except :
  PA10SysCtrlr.services['PA10SysCtrlrProv'].provided['SystemControl'].ref.PA10DrinkServeReq(4)
  end_all(env)
  print"Error Occurred! Finalize this Drink Serveice."
  print"---------------------------------------------"
  print traceback.format_exc(sys.exc_info()[2])
  print"---------------------------------------------"


