// -*-C++-*-
/*!
 * @file  ManipulatorCommonInterface_CommonSVC_impl.h
 * @brief Service implementation header of ManipulatorCommonInterface_Common.idl
 *
 */

#include "ManipulatorCommonInterface_CommonSkel.h"


#ifndef MANIPULATORCOMMONINTERFACE_COMMONSVC_IMPL_H
#define MANIPULATORCOMMONINTERFACE_COMMONSVC_IMPL_H
 
/*
 * Example class implementing IDL interface ManipulatorCommonInterface_Common
 */
class ManipulatorCommonInterface_CommonSVC_impl
 : public virtual POA_ManipulatorCommonInterface_Common,
   public virtual PortableServer::RefCountServantBase
{
 private:
   // Make sure all instances are built on the heap by making the
   // destructor non-public
   //virtual ~ManipulatorCommonInterface_CommonSVC_impl();

 public:
   // standard constructor
   ManipulatorCommonInterface_CommonSVC_impl();
   virtual ~ManipulatorCommonInterface_CommonSVC_impl();

   // attributes and operations
   RTC::RETURN_ID* clearAlarms();
   RTC::RETURN_ID* getActiveAlarm(RTC::AlarmSeq_out alarms);
   RTC::RETURN_ID* getFeedbackPosJoint(RTC::JointPos_out pos);
   RTC::RETURN_ID* getManipInfo(RTC::ManipInfo_out manipInfo);
   RTC::RETURN_ID* getSoftLimitJoint(RTC::LimitSeq_out softLimit);
   RTC::RETURN_ID* getState(RTC::ULONG& state);
   RTC::RETURN_ID* servoOFF();
   RTC::RETURN_ID* servoON();
   RTC::RETURN_ID* setSoftLimitJoint(const RTC::LimitSeq& softLimit);

};



#endif // MANIPULATORCOMMONINTERFACE_COMMONSVC_IMPL_H


