// -*-C++-*-
/*!
 * @file  com_handSVC_impl.h
 * @brief Service implementation header of com_hand.idl
 *
 */

#include "com_handSkel.h"
#include <rtm/SystemLogger.h>

#ifndef com_handSVC_IMPL_H
#define com_handSVC_IMPL_H
 
#include "apidio.h"											// Header file for API-DIO
#include "resource.h"										// Resource file

/*!
 * @class ComHandSVC_impl
 * Example class implementing IDL interface ComHand
 */
class ComHandSVC_impl
 : public virtual POA_ComHand,
   public virtual PortableServer::RefCountServantBase
{
 private:
   // Make sure all instances are built on the heap by making the
   // destructor non-public
   //virtual ~ComHandSVC_impl();
   RTC::Logger rtclog;

 public:
  /*!
   * @brief standard constructor
   */
   ComHandSVC_impl();
  /*!
   * @brief destructor
   */
   virtual ~ComHandSVC_impl();

   // attributes and operations
   CORBA::Short InitHand();
   CORBA::Short OpenHand(CORBA::Short slow);		// slow 0:normal speed 1:slow speed
   CORBA::Short CloseHand(CORBA::Short slow);
   CORBA::Short StopHand();
   CORBA::Short GetHandCond();
   CORBA::Short GetHandMode();


   HANDLE hDrv;

   DINP lpDInp;
   BYTE	BufIn[1];
   WORD	InpPortNo[1];

   DOUT	LpDOut;
   BYTE	BufOut[1];
   WORD	OutPortNo[1];

   short cond;		// 1:moving       2:open         3:close        4:interrupted
   short old_bit;
   short mode;		// 1;open         2:open slowly  3:close        4:close slowly
   
};



#endif // com_handSVC_IMPL_H


