// -*-C++-*-
/*!
 * @file  com_pa10SVC_impl.cpp
 * @brief Service implementation code of com_pa10.idl
 *
 * @author FSI
 *
 */

#include "com_pa10SVC_impl.h"

/*
 * Example implementational code for IDL interface ComPA10
 */
ComPA10SVC_impl::ComPA10SVC_impl()
:rtclog("ComPA10SVC_impl")
{
  // Please add extra constructor code here.
}


ComPA10SVC_impl::~ComPA10SVC_impl()
{
  // Please add extra destructor code here.
}


/*
 * Methods corresponding to IDL attributes and operations
 */
CORBA::Long ComPA10SVC_impl::move_here_pa10()
{
  // Please insert your code here and remove the following warning pragma
#ifndef WIN32
  #warning "Code missing in function <CORBA::Long ComPA10SVC_impl::move_here_pa10()>"
#endif

  long err;
  ANGLE angle;

  RTC_ERROR(("+++++ move_here_pa10:start +++++"));

  err = pa_get_agl(ARM0,&angle);
  RTC_ERROR(("pa_get_agl():%d", err));
  err = pa_exe_axs(ARM0,AXISALL,&angle,WM_WAIT);
  RTC_ERROR(("pa_exe_axs():%d", err));

  RTC_ERROR(("+++++ move_here_pa10:end   +++++"));

  return(err);
}

CORBA::Long ComPA10SVC_impl::reset_pa10()
{
  // Please insert your code here and remove the following warning pragma
#ifndef WIN32
  #warning "Code missing in function <CORBA::Long ComPA10SVC_impl::reset_pa10()>"
#endif

  long err;

  RTC_ERROR(("+++++ reset_pa10:start +++++"));

  // initialize PA10 library
  err = pa_ini_sys();      
  RTC_ERROR(("pa_ini_sys():%d", err));
  // open ARM0
  err = pa_opn_arm(ARM0);
  RTC_ERROR(("pa_opn_arm():%d", err));
  // start ARM0
  err = pa_sta_arm(ARM0);
  RTC_ERROR(("pa_sta_arm():%d", err));
  // reset error infomation
  err = pa_rst_ctl(ARM0);
  RTC_ERROR(("pa_rst_ctl():%d", err));
  err = move_here_pa10();

  RTC_ERROR(("+++++ reset_pa10:end   +++++"));
  return(err);
}

CORBA::Long ComPA10SVC_impl::init_pa10()
{
  // Please insert your code here and remove the following warning pragma
#ifndef WIN32
  #warning "Code missing in function <CORBA::Long ComPA10SVC_impl::init_pa10()>"
#endif

  int i;
  long err;
  ANGLE an;
  PARAM para;

  RTC_ERROR(("+++++ init_pa10:start +++++"));
  err = reset_pa10();

  // init position setting
  an.s1 =  0.0;
  an.s2 =  M_PI/9;
  an.s3 =  0.0;
  an.e1 =  M_PI/3;
  an.e2 =  0.0;
  an.w1 =  5*M_PI/9;
  an.w2 =  0.0;
//  an.w2 =  M_PI;
  err = pa_exe_axs(ARM0,AXISALL,&an,WM_WAIT);
  RTC_ERROR(("pa_exe_axs():%d", err));

  err = pa_get_prm(ARM0, &para);
  RTC_ERROR(("pa_get_prm():%d", err));
  for(i=0;i<7;i++) {
    m_vel_lim[i] = para.vel[i];
  }

  RTC_ERROR(("+++++ init_pa10:end   +++++"));

  return(err);
}

CORBA::Long ComPA10SVC_impl::on_pa10()
{
  // Please insert your code here and remove the following warning pragma
#ifndef WIN32
  #warning "Code missing in function <CORBA::Long ComPA10SVC_impl::on_pa10()>"
#endif

  int i;
  long err;
  float j_vel[7];

  RTC_ERROR(("+++++ on_pa10:start   +++++"));

  for(i=0;i<7;i++) j_vel[i] = 0.0;

  // timeout setting(ms)
  err=pa_set_tim(ARM0,100);
  RTC_ERROR(("pa_set_tim():%d", err));
  err=pa_mod_vel(ARM0,VM_ONE,S1|S2|S3|E1|E2|W1|W2);
  RTC_ERROR(("pa_mod_vel():%d", err));
  err=pa_odr_vel(ARM0,j_vel);
  RTC_ERROR(("pa_odr_vel():%d", err));

  RTC_ERROR(("+++++ on_pa10:end     +++++"));

  return(err);
}

CORBA::Long ComPA10SVC_impl::off_pa10()
{
  // Please insert your code here and remove the following warning pragma
#ifndef WIN32
  #warning "Code missing in function <CORBA::Long ComPA10SVC_impl::off_pa10()>"
#endif

  int i;
  long err;
  float j_vel[7];

  RTC_ERROR(("+++++ off_pa10:start   +++++"));

  for(i=0;i<7;i++) j_vel[i] = 0.0;
  err=pa_odr_vel(ARM0,j_vel);
  RTC_ERROR(("pa_odr_vel():%d", err));
  err=pa_sus_arm(ARM0,WM_WAIT);
  RTC_ERROR(("pa_sus_arm():%d", err));

  RTC_ERROR(("+++++ off_pa10:end     +++++"));
  return(err);
}

CORBA::Long ComPA10SVC_impl::end_pa10()
{
  // Please insert your code here and remove the following warning pragma
#ifndef WIN32
  #warning "Code missing in function <CORBA::Long ComPA10SVC_impl::end_pa10()>"
#endif

  long err;

  RTC_ERROR(("+++++ end_pa10:start   +++++"));

  err=pa_exe_hom(ARM0, WM_WAIT);
  RTC_ERROR(("pa_exe_hom():%d", err));
  Sleep(5);
  err=pa_ext_arm(ARM0);
  RTC_ERROR(("pa_ext_arm():%d", err));
  err=pa_cls_arm(ARM0);
  RTC_ERROR(("pa_cls_arm():%d", err));
  err=pa_ter_sys(); 
  RTC_ERROR(("pa_ter_sys():%d", err));

  RTC_ERROR(("+++++ end_pa10:end     +++++"));
  return(err);
}

void ComPA10SVC_impl::set_flg(CORBA::Long flg)
{
  // Please insert your code here and remove the following warning pragma
#ifndef WIN32
  #warning "Code missing in function <void ComPA10SVC_impl::set_flg(CORBA::Long flg)>"
#endif

    m_act_flg = flg;
}



// End of example implementational code



